/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * Elements, a Sable suite of simple Java programs                   *
 * Copyright (C) 1998 Raja Vallee-Rai (kor@sable.mcgill.ca)          *
 * All rights reserved.                                              *
 *                                                                   *
 * This work was done as a project of the Sable Research Group,      *
 * School of Computer Science, McGill University, Canada             *
 * (http://www.sable.mcgill.ca/).  It is understood that any         *
 * modification not identified as such is not covered by the         *
 * preceding statement.                                              *
 *                                                                   *
 * This work is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU Library General Public       *
 * License as published by the Free Software Foundation; either      *
 * version 2 of the License, or (at your option) any later version.  *
 *                                                                   *
 * This work is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *
 * Library General Public License for more details.                  *
 *                                                                   *
 * You should have received a copy of the GNU Library General Public *
 * License along with this library; if not, write to the             *
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,      *
 * Boston, MA  02111-1307, USA.                                      *
 *                                                                   *
 * Java is a trademark of Sun Microsystems, Inc.                     *
 *                                                                   *
 * To submit a bug report, send a comment, or get the latest news on *
 * this project and other Sable Research Group projects, please      *
 * visit the web site: http://www.sable.mcgill.ca/                   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*
 Reference Version
 -----------------
 This is the latest official version on which this file is based.
 The reference version is: $?$

 Change History
 --------------
 A) Notes:

 Please use the following template.  Most recent changes should
 appear at the top of the list.

 - Modified on [date (March 1, 1900)] by [name]. [(*) if appropriate]
   [description of modification].

 Any Modification flagged with "(*)" was done as a project of the
 Sable Research Group, School of Computer Science,
 McGill University, Canada (http://www.sable.mcgill.ca/).

 You should add your copyright, using the following template, at
 the top of this file, along with other copyrights.

 *                                                                   *
 * Modifications by [name] are                                       *
 * Copyright (C) [year(s)] [your name (or company)].  All rights     *
 * reserved.                                                         *
 *                                                                   *

 B) Changes:

 - Modified on September 12, 1998 by Raja Vallee-Rai (kor@sable.mcgill.ca) (*)
   First internal release.
*/

class Main
{
    final static int SIZE = 10;
    
    public static void main(String[] args)
    {
        int[][] map1 = new int[SIZE][SIZE];
        int[][] map2 = new int[SIZE][SIZE];
        
        int[][] currentMap = map1;
        int[][] nextMap = map2;

        // Put boundary
            for(int x = 0; x < SIZE; x++)
                for(int y = 0; y < SIZE; y++)
                {
                    if(x == 0 || x == SIZE - 1 || y == 0 || y == SIZE - 1)
                    {
                        currentMap[x][y] = 2;
                        nextMap[x][y] = 2;
                    }
                       
                }
               
        // Put a glider in        
            currentMap[2][1] = 1;
            currentMap[3][2] = 1;
            currentMap[1][3] = 1;
            currentMap[2][3] = 1;
            currentMap[3][3] = 1;
            
        // Perform simulation
            for(int i = 0; i < 15; i++)
            {
                // Print out map
                {
                    System.out.println();
                    
                    for(int y = 0; y < SIZE; y++)
                    {
                        for(int x = 0; x < SIZE; x++)
                        {
                            switch(currentMap[x][y])
                            {
                                case 0:
                                    System.out.print(" ");
                                    break;
                                    
                                case 1:
                                    System.out.print("*");
                                    break;
                                    
                                case 2:
                                    System.out.print("#");   
                                    break; 
                            }
                        }
                        
                        System.out.println();
                    }
                }
                
                // Determine state of next map
                    for(int x = 1; x < SIZE - 1; x++)
                        for(int y = 1; y < SIZE - 1; y++)
                        {
                            int numAliveSquares = 0;
                            
                            if(currentMap[x-1][y] == 1)
                                numAliveSquares++;
                                    
                            if(currentMap[x+1][y] == 1)
                                numAliveSquares++;
                                
                            if(currentMap[x][y-1] == 1)
                                numAliveSquares++;
                                
                            if(currentMap[x][y+1] == 1)
                                numAliveSquares++;
                            
                            if(currentMap[x-1][y-1] == 1)
                                numAliveSquares++;
                                    
                            if(currentMap[x-1][y+1] == 1)
                                numAliveSquares++;
                                
                            if(currentMap[x+1][y-1] == 1)
                                numAliveSquares++;
                                
                            if(currentMap[x+1][y+1] == 1)
                                numAliveSquares++;
                            
                            if(currentMap[x][y] == 1)
                            {
                                if(numAliveSquares < 2 || numAliveSquares > 3)
                                    nextMap[x][y] = 0;
                                else
                                    nextMap[x][y] = 1;
                            }
                            else
                            {
                                if(numAliveSquares == 3)
                                    nextMap[x][y] = 1;
                                else
                                    nextMap[x][y] = 0;
                            }
                        }
                        
                // Perform swap
                {
                    int[][] tmpMap = currentMap;
                    
                    currentMap = nextMap;
                    nextMap = tmpMap;
                }
                
                
            }    
    }
    
}



