/* This file was generated by SableCC (http://www.sable.mcgill.ca/sablecc/). */

package soot.jimple.parser.lexer;

import java.io.*;
import java.util.*;
import soot.jimple.parser.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("Unable to read lexer.dat.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

	int[][][] gotoTable = this.gotoTable[state.id()];
	int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 35:
                        {
                            Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 36:
                        {
                            Token token = new36(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 37:
                        {
                            Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 38:
                        {
                            Token token = new38(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 39:
                        {
                            Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 40:
                        {
                            Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 41:
                        {
                            Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 42:
                        {
                            Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 43:
                        {
                            Token token = new43(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 44:
                        {
                            Token token = new44(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 45:
                        {
                            Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 46:
                        {
                            Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 47:
                        {
                            Token token = new47(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 48:
                        {
                            Token token = new48(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 49:
                        {
                            Token token = new49(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 50:
                        {
                            Token token = new50(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 51:
                        {
                            Token token = new51(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 52:
                        {
                            Token token = new52(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 53:
                        {
                            Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 54:
                        {
                            Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 55:
                        {
                            Token token = new55(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 56:
                        {
                            Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 57:
                        {
                            Token token = new57(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 58:
                        {
                            Token token = new58(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 59:
                        {
                            Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 60:
                        {
                            Token token = new60(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 61:
                        {
                            Token token = new61(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 62:
                        {
                            Token token = new62(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 63:
                        {
                            Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 64:
                        {
                            Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 65:
                        {
                            Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 66:
                        {
                            Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 67:
                        {
                            Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 68:
                        {
                            Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 69:
                        {
                            Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 70:
                        {
                            Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 71:
                        {
                            Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 72:
                        {
                            Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 73:
                        {
                            Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 74:
                        {
                            Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 75:
                        {
                            Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 76:
                        {
                            Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 77:
                        {
                            Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 78:
                        {
                            Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 79:
                        {
                            Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 80:
                        {
                            Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 81:
                        {
                            Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 82:
                        {
                            Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 83:
                        {
                            Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 84:
                        {
                            Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 85:
                        {
                            Token token = new85(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 86:
                        {
                            Token token = new86(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 87:
                        {
                            Token token = new87(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 88:
                        {
                            Token token = new88(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 89:
                        {
                            Token token = new89(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 90:
                        {
                            Token token = new90(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 91:
                        {
                            Token token = new91(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 92:
                        {
                            Token token = new92(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TIgnored(text, line, pos); }
    Token new1(int line, int pos) { return new TAbstract(line, pos); }
    Token new2(int line, int pos) { return new TFinal(line, pos); }
    Token new3(int line, int pos) { return new TNative(line, pos); }
    Token new4(int line, int pos) { return new TPublic(line, pos); }
    Token new5(int line, int pos) { return new TProtected(line, pos); }
    Token new6(int line, int pos) { return new TPrivate(line, pos); }
    Token new7(int line, int pos) { return new TStatic(line, pos); }
    Token new8(int line, int pos) { return new TSynchronized(line, pos); }
    Token new9(int line, int pos) { return new TTransient(line, pos); }
    Token new10(int line, int pos) { return new TVolatile(line, pos); }
    Token new11(int line, int pos) { return new TClass(line, pos); }
    Token new12(int line, int pos) { return new TInterface(line, pos); }
    Token new13(int line, int pos) { return new TVoid(line, pos); }
    Token new14(int line, int pos) { return new TBoolean(line, pos); }
    Token new15(int line, int pos) { return new TByte(line, pos); }
    Token new16(int line, int pos) { return new TShort(line, pos); }
    Token new17(int line, int pos) { return new TChar(line, pos); }
    Token new18(int line, int pos) { return new TInt(line, pos); }
    Token new19(int line, int pos) { return new TLong(line, pos); }
    Token new20(int line, int pos) { return new TFloat(line, pos); }
    Token new21(int line, int pos) { return new TDouble(line, pos); }
    Token new22(int line, int pos) { return new TNullType(line, pos); }
    Token new23(int line, int pos) { return new TUnknown(line, pos); }
    Token new24(int line, int pos) { return new TExtends(line, pos); }
    Token new25(int line, int pos) { return new TImplements(line, pos); }
    Token new26(int line, int pos) { return new TBreakpoint(line, pos); }
    Token new27(int line, int pos) { return new TCase(line, pos); }
    Token new28(int line, int pos) { return new TCatch(line, pos); }
    Token new29(int line, int pos) { return new TCmp(line, pos); }
    Token new30(int line, int pos) { return new TCmpg(line, pos); }
    Token new31(int line, int pos) { return new TCmpl(line, pos); }
    Token new32(int line, int pos) { return new TDefault(line, pos); }
    Token new33(int line, int pos) { return new TEntermonitor(line, pos); }
    Token new34(int line, int pos) { return new TExitmonitor(line, pos); }
    Token new35(int line, int pos) { return new TGoto(line, pos); }
    Token new36(int line, int pos) { return new TIf(line, pos); }
    Token new37(int line, int pos) { return new TInstanceof(line, pos); }
    Token new38(int line, int pos) { return new TInterfaceinvoke(line, pos); }
    Token new39(int line, int pos) { return new TLengthof(line, pos); }
    Token new40(int line, int pos) { return new TLookupswitch(line, pos); }
    Token new41(int line, int pos) { return new TNeg(line, pos); }
    Token new42(int line, int pos) { return new TNew(line, pos); }
    Token new43(int line, int pos) { return new TNewarray(line, pos); }
    Token new44(int line, int pos) { return new TNewmultiarray(line, pos); }
    Token new45(int line, int pos) { return new TNop(line, pos); }
    Token new46(int line, int pos) { return new TRet(line, pos); }
    Token new47(int line, int pos) { return new TReturn(line, pos); }
    Token new48(int line, int pos) { return new TSpecialinvoke(line, pos); }
    Token new49(int line, int pos) { return new TStaticinvoke(line, pos); }
    Token new50(int line, int pos) { return new TTableswitch(line, pos); }
    Token new51(int line, int pos) { return new TThrow(line, pos); }
    Token new52(int line, int pos) { return new TThrows(line, pos); }
    Token new53(int line, int pos) { return new TVirtualinvoke(line, pos); }
    Token new54(int line, int pos) { return new TNull(line, pos); }
    Token new55(int line, int pos) { return new TComma(line, pos); }
    Token new56(int line, int pos) { return new TLBrace(line, pos); }
    Token new57(int line, int pos) { return new TRBrace(line, pos); }
    Token new58(int line, int pos) { return new TSemicolon(line, pos); }
    Token new59(int line, int pos) { return new TLBracket(line, pos); }
    Token new60(int line, int pos) { return new TRBracket(line, pos); }
    Token new61(int line, int pos) { return new TLParen(line, pos); }
    Token new62(int line, int pos) { return new TRParen(line, pos); }
    Token new63(int line, int pos) { return new TColon(line, pos); }
    Token new64(int line, int pos) { return new TDot(line, pos); }
    Token new65(int line, int pos) { return new TQuote(line, pos); }
    Token new66(int line, int pos) { return new TColonEquals(line, pos); }
    Token new67(int line, int pos) { return new TEquals(line, pos); }
    Token new68(int line, int pos) { return new TAnd(line, pos); }
    Token new69(int line, int pos) { return new TOr(line, pos); }
    Token new70(int line, int pos) { return new TXor(line, pos); }
    Token new71(int line, int pos) { return new TMod(line, pos); }
    Token new72(int line, int pos) { return new TCmpeq(line, pos); }
    Token new73(int line, int pos) { return new TCmpne(line, pos); }
    Token new74(int line, int pos) { return new TCmpgt(line, pos); }
    Token new75(int line, int pos) { return new TCmpge(line, pos); }
    Token new76(int line, int pos) { return new TCmplt(line, pos); }
    Token new77(int line, int pos) { return new TCmple(line, pos); }
    Token new78(int line, int pos) { return new TShl(line, pos); }
    Token new79(int line, int pos) { return new TShr(line, pos); }
    Token new80(int line, int pos) { return new TUshr(line, pos); }
    Token new81(int line, int pos) { return new TPlus(line, pos); }
    Token new82(int line, int pos) { return new TMinus(line, pos); }
    Token new83(int line, int pos) { return new TMult(line, pos); }
    Token new84(int line, int pos) { return new TDiv(line, pos); }
    Token new85(String text, int line, int pos) { return new TFullIdentifier(text, line, pos); }
    Token new86(String text, int line, int pos) { return new TQuotedName(text, line, pos); }
    Token new87(String text, int line, int pos) { return new TIdentifier(text, line, pos); }
    Token new88(String text, int line, int pos) { return new TAtIdentifier(text, line, pos); }
    Token new89(String text, int line, int pos) { return new TBoolConstant(text, line, pos); }
    Token new90(String text, int line, int pos) { return new TIntegerConstant(text, line, pos); }
    Token new91(String text, int line, int pos) { return new TFloatConstant(text, line, pos); }
    Token new92(String text, int line, int pos) { return new TStringConstant(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {33, 33, 5}, {34, 34, 6}, {35, 35, 7}, {36, 36, 8}, {37, 37, 9}, {38, 38, 10}, {39, 39, 11}, {40, 40, 12}, {41, 41, 13}, {42, 42, 14}, {43, 43, 15}, {44, 44, 16}, {45, 45, 17}, {46, 46, 18}, {47, 47, 19}, {48, 48, 20}, {49, 57, 21}, {58, 58, 22}, {59, 59, 23}, {60, 60, 24}, {61, 61, 25}, {62, 62, 26}, {64, 64, 27}, {65, 90, 28}, {91, 91, 29}, {92, 92, 30}, {93, 93, 31}, {94, 94, 32}, {95, 95, 33}, {97, 101, 34}, {102, 102, 35}, {103, 115, 34}, {116, 116, 36}, {117, 122, 34}, {123, 123, 37}, {124, 124, 38}, {125, 125, 39}, },
            {{9, 32, -2}, {47, 47, 40}, },
            {{9, 47, -3}, },
            {{9, 47, -3}, },
            {{9, 47, -3}, },
            {{61, 61, 41}, },
            {{0, 33, 42}, {34, 34, 43}, {35, 91, 44}, {92, 92, 45}, {93, 127, 46}, },
            {{45, 45, 47}, {73, 73, 48}, {78, 78, 49}, },
            {{36, 36, 50}, {46, 46, 51}, {48, 57, 52}, {65, 90, 53}, {92, 92, 54}, {95, 95, 55}, {97, 122, 56}, },
            {},
            {},
            {{0, 9, 57}, {11, 12, 57}, {14, 38, 57}, {40, 65535, 57}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{97, 97, 58}, {98, 98, 59}, {99, 99, 60}, {100, 100, 61}, {101, 101, 62}, {102, 102, 63}, {103, 103, 64}, {105, 105, 65}, {108, 108, 66}, {110, 110, 67}, {112, 112, 68}, {114, 114, 69}, {115, 115, 70}, {116, 116, 71}, {117, 117, 72}, {118, 118, 73}, },
            {{42, 42, 74}, {47, 47, 75}, },
            {{46, 46, 76}, {48, 55, 77}, {56, 57, 21}, {76, 76, 78}, {88, 88, 79}, {120, 120, 80}, },
            {{46, 46, 76}, {48, 57, 21}, {76, 76, 78}, },
            {{61, 61, 81}, },
            {},
            {{60, 60, 82}, {61, 61, 83}, {99, 99, 84}, {105, 105, 85}, },
            {{61, 61, 86}, },
            {{61, 61, 87}, {62, 62, 88}, },
            {{99, 99, 89}, {112, 112, 90}, {116, 116, 91}, },
            {{36, 122, -10}, },
            {},
            {{32, 32, 92}, {34, 34, 93}, {35, 35, 94}, {39, 39, 95}, {46, 46, 96}, {92, 92, 97}, {98, 98, 98}, {102, 102, 99}, {110, 110, 100}, {114, 114, 101}, {116, 116, 102}, {117, 117, 103}, },
            {},
            {},
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 95, -10}, {97, 97, 104}, {98, 122, 56}, },
            {{36, 95, -10}, {97, 113, 56}, {114, 114, 105}, {115, 122, 56}, },
            {},
            {},
            {},
            {{42, 47, -21}, },
            {},
            {{0, 127, -8}, },
            {},
            {{0, 127, -8}, },
            {{32, 32, 106}, {34, 34, 107}, {35, 35, 108}, {39, 39, 109}, {46, 46, 110}, {92, 92, 111}, {98, 98, 112}, {102, 102, 113}, {110, 110, 114}, {114, 114, 115}, {116, 116, 116}, {117, 117, 117}, },
            {{0, 127, -8}, },
            {{73, 73, 48}, },
            {{110, 110, 118}, },
            {{97, 97, 119}, },
            {{36, 122, -10}, },
            {{36, 36, 120}, {65, 90, 121}, {92, 92, 122}, {95, 95, 123}, {97, 122, 124}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{32, 32, 125}, {34, 34, 126}, {35, 35, 127}, {39, 39, 128}, {46, 46, 129}, {92, 92, 130}, {98, 98, 131}, {102, 102, 132}, {110, 110, 133}, {114, 114, 134}, {116, 116, 135}, {117, 117, 136}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{0, 38, -13}, {39, 39, 137}, {40, 65535, 57}, },
            {{98, 98, 138}, },
            {{111, 111, 139}, {114, 114, 140}, {121, 121, 141}, },
            {{97, 97, 142}, {104, 104, 143}, {108, 108, 144}, {109, 109, 145}, },
            {{101, 101, 146}, {111, 111, 147}, },
            {{110, 110, 148}, {120, 120, 149}, },
            {{105, 105, 150}, {108, 108, 151}, },
            {{111, 111, 152}, },
            {{102, 102, 153}, {109, 109, 154}, {110, 110, 155}, },
            {{101, 101, 156}, {111, 111, 157}, },
            {{97, 97, 158}, {101, 101, 159}, {111, 111, 160}, {117, 117, 161}, },
            {{114, 114, 162}, {117, 117, 163}, },
            {{101, 101, 164}, },
            {{104, 104, 165}, {112, 112, 166}, {116, 116, 167}, {121, 121, 168}, },
            {{97, 97, 169}, {104, 104, 170}, {114, 114, 171}, },
            {{110, 110, 172}, },
            {{105, 105, 173}, {111, 111, 174}, },
            {{0, 41, 175}, {42, 42, 176}, {43, 65535, 175}, },
            {{0, 8, 177}, {9, 9, 178}, {10, 10, 2}, {11, 12, 177}, {13, 13, 3}, {14, 31, 177}, {32, 32, 179}, {33, 46, 177}, {47, 47, 180}, {48, 65535, 177}, },
            {{48, 57, 181}, },
            {{46, 76, -22}, },
            {},
            {{48, 57, 182}, {65, 70, 183}, {97, 102, 184}, },
            {{48, 102, -81}, },
            {},
            {},
            {},
            {{108, 108, 185}, },
            {{110, 110, 186}, },
            {},
            {},
            {{62, 62, 187}, },
            {{97, 97, 188}, },
            {{97, 97, 189}, },
            {{104, 104, 190}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{48, 57, 191}, {65, 70, 192}, {97, 102, 193}, },
            {{36, 95, -10}, {97, 107, 56}, {108, 108, 194}, {109, 122, 56}, },
            {{36, 95, -10}, {97, 116, 56}, {117, 117, 195}, {118, 122, 56}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{48, 57, 196}, {65, 70, 197}, {97, 102, 198}, },
            {{102, 102, 199}, },
            {{78, 78, 200}, },
            {{36, 36, 201}, {46, 46, 51}, {48, 57, 202}, {65, 90, 203}, {92, 92, 204}, {95, 95, 205}, {97, 122, 206}, },
            {{36, 122, -122}, },
            {{32, 32, 207}, {34, 34, 208}, {35, 35, 209}, {39, 39, 210}, {46, 46, 211}, {92, 92, 212}, {98, 98, 213}, {102, 102, 214}, {110, 110, 215}, {114, 114, 216}, {116, 116, 217}, {117, 117, 218}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{48, 57, 219}, {65, 70, 220}, {97, 102, 221}, },
            {},
            {{115, 115, 222}, },
            {{111, 111, 223}, },
            {{101, 101, 224}, },
            {{116, 116, 225}, },
            {{115, 115, 226}, {116, 116, 227}, },
            {{97, 97, 228}, },
            {{97, 97, 229}, },
            {{112, 112, 230}, },
            {{102, 102, 231}, },
            {{117, 117, 232}, },
            {{116, 116, 233}, },
            {{105, 105, 234}, {116, 116, 235}, },
            {{110, 110, 236}, },
            {{111, 111, 237}, },
            {{116, 116, 238}, },
            {},
            {{112, 112, 239}, },
            {{115, 115, 240}, {116, 116, 241}, },
            {{110, 110, 242}, },
            {{110, 110, 243}, {111, 111, 244}, },
            {{116, 116, 245}, },
            {{103, 103, 246}, {119, 119, 247}, },
            {{112, 112, 248}, },
            {{108, 108, 249}, },
            {{105, 105, 250}, {111, 111, 251}, },
            {{98, 98, 252}, },
            {{116, 116, 253}, },
            {{111, 111, 254}, },
            {{101, 101, 255}, },
            {{97, 97, 256}, },
            {{110, 110, 257}, },
            {{98, 98, 258}, },
            {{114, 114, 259}, },
            {{97, 97, 260}, },
            {{107, 107, 261}, },
            {{114, 114, 262}, },
            {{105, 105, 263}, {108, 108, 264}, },
            {{0, 65535, -76}, },
            {{0, 41, 265}, {42, 42, 176}, {43, 46, 265}, {47, 47, 266}, {48, 65535, 265}, },
            {{0, 65535, -77}, },
            {{0, 65535, -77}, },
            {{0, 65535, -77}, },
            {{0, 32, -77}, {33, 41, 177}, {42, 42, 267}, {43, 46, 177}, {47, 47, 268}, {48, 65535, 177}, },
            {{48, 57, 181}, {69, 69, 269}, {70, 70, 270}, {101, 101, 271}, {102, 102, 272}, },
            {{48, 70, -81}, {76, 76, 78}, {97, 102, 184}, },
            {{48, 102, -184}, },
            {{48, 102, -184}, },
            {{105, 105, 273}, },
            {{105, 105, 274}, },
            {},
            {{117, 117, 275}, },
            {{114, 114, 276}, },
            {{105, 105, 277}, },
            {{48, 57, 278}, {65, 70, 279}, {97, 102, 280}, },
            {{48, 102, -193}, },
            {{48, 102, -193}, },
            {{36, 95, -10}, {97, 114, 56}, {115, 115, 281}, {116, 122, 56}, },
            {{36, 95, -10}, {97, 100, 56}, {101, 101, 282}, {102, 122, 56}, },
            {{48, 57, 283}, {65, 70, 284}, {97, 102, 285}, },
            {{48, 102, -198}, },
            {{48, 102, -198}, },
            {{105, 105, 286}, },
            {{70, 70, 287}, {102, 102, 288}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{32, 32, 289}, {34, 34, 290}, {35, 35, 291}, {39, 39, 292}, {46, 46, 293}, {92, 92, 294}, {98, 98, 295}, {102, 102, 296}, {110, 110, 297}, {114, 114, 298}, {116, 116, 299}, {117, 117, 300}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{48, 57, 301}, {65, 70, 302}, {97, 102, 303}, },
            {{48, 57, 304}, {65, 70, 305}, {97, 102, 306}, },
            {{48, 102, -221}, },
            {{48, 102, -221}, },
            {{116, 116, 307}, },
            {{108, 108, 308}, },
            {{97, 97, 309}, },
            {{101, 101, 310}, },
            {{101, 101, 311}, },
            {{99, 99, 312}, },
            {{114, 114, 313}, },
            {{115, 115, 314}, },
            {{103, 103, 315}, {108, 108, 316}, },
            {{97, 97, 317}, },
            {{98, 98, 318}, },
            {{101, 101, 319}, },
            {{116, 116, 320}, },
            {{101, 101, 321}, },
            {{97, 97, 322}, },
            {{97, 97, 323}, },
            {{111, 111, 324}, },
            {{108, 108, 325}, },
            {{116, 116, 326}, },
            {{101, 101, 327}, },
            {{103, 103, 328}, },
            {{103, 103, 329}, },
            {{107, 107, 330}, },
            {{105, 105, 331}, },
            {},
            {{97, 97, 332}, {109, 109, 333}, },
            {},
            {{108, 108, 334}, },
            {{118, 118, 335}, },
            {{116, 116, 336}, },
            {{108, 108, 337}, },
            {{117, 117, 338}, },
            {{114, 114, 339}, },
            {{99, 99, 340}, },
            {{116, 116, 341}, },
            {{99, 99, 342}, },
            {{108, 108, 343}, },
            {{111, 111, 344}, },
            {{110, 110, 345}, },
            {{110, 110, 346}, },
            {{116, 116, 347}, },
            {{100, 100, 348}, },
            {{97, 97, 349}, },
            {{0, 41, 350}, {42, 42, 351}, {43, 65535, 350}, },
            {{9, 47, -3}, },
            {{0, 8, 352}, {9, 9, 353}, {10, 10, 354}, {11, 12, 352}, {13, 13, 355}, {14, 31, 352}, {32, 32, 356}, {33, 41, 352}, {42, 42, 357}, {43, 46, 352}, {47, 47, 358}, {48, 65535, 352}, },
            {{0, 65535, -182}, },
            {{43, 43, 359}, {45, 45, 360}, {48, 57, 361}, },
            {},
            {{43, 57, -271}, },
            {},
            {{110, 110, 362}, },
            {{116, 116, 363}, },
            {{103, 103, 364}, },
            {{97, 97, 365}, },
            {{115, 115, 366}, },
            {{48, 57, 367}, {65, 70, 368}, {97, 102, 369}, },
            {{48, 102, -280}, },
            {{48, 102, -280}, },
            {{36, 100, -197}, {101, 101, 370}, {102, 122, 56}, },
            {{36, 122, -10}, },
            {{48, 57, 371}, {65, 70, 372}, {97, 102, 373}, },
            {{48, 102, -285}, },
            {{48, 102, -285}, },
            {{110, 110, 374}, },
            {},
            {},
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{48, 57, 375}, {65, 70, 376}, {97, 102, 377}, },
            {{48, 57, 378}, {65, 70, 379}, {97, 102, 380}, },
            {{48, 102, -303}, },
            {{48, 102, -303}, },
            {{48, 57, 381}, {65, 70, 382}, {97, 102, 383}, },
            {{48, 102, -306}, },
            {{48, 102, -306}, },
            {{114, 114, 384}, },
            {{101, 101, 385}, },
            {{107, 107, 386}, },
            {},
            {},
            {{104, 104, 387}, },
            {},
            {{115, 115, 388}, },
            {},
            {},
            {{117, 117, 389}, },
            {{108, 108, 390}, },
            {{114, 114, 391}, },
            {{109, 109, 392}, },
            {{110, 110, 393}, },
            {{108, 108, 394}, },
            {{116, 116, 395}, },
            {},
            {{101, 101, 396}, },
            {{97, 97, 397}, },
            {{114, 114, 398}, },
            {{116, 116, 399}, },
            {},
            {{117, 117, 400}, },
            {{118, 118, 401}, },
            {{114, 114, 402}, },
            {{117, 117, 403}, },
            {{95, 95, 404}, },
            {{97, 97, 405}, },
            {{101, 101, 406}, },
            {{105, 105, 407}, },
            {{114, 114, 408}, },
            {{116, 116, 409}, },
            {{105, 105, 410}, },
            {{105, 105, 411}, },
            {{104, 104, 412}, },
            {{101, 101, 413}, },
            {{119, 119, 414}, },
            {{115, 115, 415}, },
            {{111, 111, 416}, },
            {{117, 117, 417}, },
            {},
            {{116, 116, 418}, },
            {{0, 65535, -267}, },
            {{0, 41, 265}, {42, 42, 351}, {43, 65535, -178}, },
            {{0, 65535, -269}, },
            {{0, 65535, -269}, },
            {{0, 8, 175}, {9, 9, 419}, {10, 10, 354}, {11, 12, 175}, {13, 13, 355}, {14, 31, 175}, {32, 32, 420}, {33, 41, 175}, {42, 42, 176}, {43, 46, 175}, {47, 47, 421}, {48, 65535, 175}, },
            {{0, 65535, -356}, },
            {{0, 65535, -269}, },
            {{0, 8, 422}, {9, 9, 423}, {10, 10, 424}, {11, 12, 422}, {13, 13, 425}, {14, 31, 422}, {32, 32, 426}, {33, 41, 422}, {42, 42, 357}, {43, 46, 422}, {47, 47, 427}, {48, 65535, 422}, },
            {{0, 41, -269}, {42, 42, 428}, {43, 46, 352}, {47, 47, 429}, {48, 65535, 352}, },
            {{48, 57, 361}, },
            {{48, 57, 361}, },
            {{48, 57, 361}, {70, 70, 270}, {102, 102, 272}, },
            {{105, 105, 430}, },
            {{62, 62, 431}, },
            {{104, 104, 432}, },
            {{109, 109, 433}, },
            {{58, 58, 434}, },
            {{48, 57, 435}, {65, 70, 436}, {97, 102, 437}, },
            {{48, 102, -369}, },
            {{48, 102, -369}, },
            {{36, 122, -10}, },
            {{48, 57, 438}, {65, 70, 439}, {97, 102, 440}, },
            {{48, 102, -373}, },
            {{48, 102, -373}, },
            {{105, 105, 441}, },
            {{48, 57, 442}, {65, 70, 443}, {97, 102, 444}, },
            {{48, 102, -377}, },
            {{48, 102, -377}, },
            {{48, 57, 445}, {65, 70, 446}, {97, 102, 447}, },
            {{48, 102, -380}, },
            {{48, 102, -380}, },
            {{48, 57, 448}, {65, 70, 449}, {97, 102, 450}, },
            {{48, 102, -383}, },
            {{48, 102, -383}, },
            {{97, 97, 451}, },
            {{97, 97, 452}, },
            {{112, 112, 453}, },
            {},
            {},
            {{108, 108, 454}, },
            {{101, 101, 455}, },
            {{109, 109, 456}, },
            {{111, 111, 457}, },
            {{100, 100, 458}, },
            {},
            {},
            {{109, 109, 459}, },
            {{110, 110, 460}, },
            {{102, 102, 461}, },
            {{104, 104, 462}, },
            {{112, 112, 463}, },
            {{101, 101, 464}, },
            {{114, 114, 465}, },
            {{108, 108, 466}, },
            {{116, 116, 467}, },
            {{116, 116, 468}, },
            {{99, 99, 469}, },
            {{99, 99, 470}, },
            {{110, 110, 471}, },
            {},
            {{97, 97, 472}, },
            {{99, 99, 473}, },
            {{114, 114, 474}, },
            {{115, 115, 475}, },
            {{115, 115, 476}, },
            {{105, 105, 477}, },
            {{119, 119, 478}, },
            {{97, 97, 479}, },
            {{105, 105, 480}, },
            {{0, 65535, -356}, },
            {{0, 65535, -356}, },
            {{0, 41, 175}, {42, 42, 481}, {43, 46, 175}, {47, 47, 482}, {48, 65535, 175}, },
            {{0, 8, 483}, {9, 9, 484}, {10, 10, 485}, {11, 12, 483}, {13, 13, 486}, {14, 31, 483}, {32, 32, 487}, {33, 41, 483}, {42, 42, 488}, {43, 46, 483}, {47, 47, 489}, {48, 65535, 483}, },
            {{0, 65535, -424}, },
            {{0, 8, 350}, {9, 9, 490}, {10, 10, 485}, {11, 12, 350}, {13, 13, 486}, {14, 31, 350}, {32, 32, 491}, {33, 41, 350}, {42, 42, 351}, {43, 46, 350}, {47, 47, 492}, {48, 65535, 350}, },
            {{0, 65535, -426}, },
            {{0, 65535, -424}, },
            {{0, 65535, -182}, },
            {{0, 8, 493}, {9, 9, 494}, {10, 10, 495}, {11, 12, 493}, {13, 13, 496}, {14, 31, 493}, {32, 32, 497}, {33, 41, 493}, {42, 42, 357}, {43, 46, 493}, {47, 47, 498}, {48, 65535, 493}, },
            {{0, 65535, -360}, },
            {{116, 116, 499}, },
            {},
            {{116, 116, 500}, },
            {{101, 101, 501}, },
            {},
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{0, 127, -8}, },
            {{116, 116, 502}, },
            {{48, 57, 503}, {65, 70, 504}, {97, 102, 505}, },
            {{48, 102, -444}, },
            {{48, 102, -444}, },
            {{48, 57, 506}, {65, 70, 507}, {97, 102, 508}, },
            {{48, 102, -447}, },
            {{48, 102, -447}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{36, 122, -10}, },
            {{99, 99, 509}, },
            {{110, 110, 510}, },
            {{111, 111, 511}, },
            {{116, 116, 512}, },
            {},
            {{111, 111, 513}, },
            {{110, 110, 514}, },
            {{115, 115, 515}, },
            {{101, 101, 516}, },
            {{99, 99, 517}, },
            {{97, 97, 518}, },
            {{111, 111, 519}, },
            {{115, 115, 520}, },
            {},
            {{97, 97, 521}, },
            {{116, 116, 522}, },
            {{121, 121, 523}, },
            {{101, 101, 524}, },
            {{116, 116, 525}, },
            {},
            {},
            {{108, 108, 526}, },
            {{105, 105, 527}, },
            {{111, 111, 528}, },
            {{119, 119, 529}, },
            {},
            {{101, 101, 530}, },
            {{110, 110, 531}, },
            {{108, 108, 532}, },
            {{108, 108, 533}, },
            {{0, 41, 534}, {42, 42, 176}, {43, 46, 534}, {47, 47, 535}, {48, 65535, 534}, },
            {{0, 65535, -269}, },
            {{0, 65535, -424}, },
            {{0, 65535, -424}, },
            {{0, 65535, -426}, },
            {{0, 65535, -426}, },
            {{0, 65535, -424}, },
            {{0, 41, -359}, {42, 42, 488}, {43, 65535, -359}, },
            {{0, 41, -424}, {42, 42, 536}, {43, 46, 483}, {47, 47, 537}, {48, 65535, 483}, },
            {{0, 65535, -426}, },
            {{0, 65535, -426}, },
            {{0, 41, 350}, {42, 42, 538}, {43, 46, 350}, {47, 47, 539}, {48, 65535, 350}, },
            {{0, 8, 540}, {9, 9, 541}, {10, 10, 542}, {11, 12, 540}, {13, 13, 543}, {14, 31, 540}, {32, 32, 544}, {33, 41, 540}, {42, 42, 545}, {43, 46, 540}, {47, 47, 546}, {48, 65535, 540}, },
            {{0, 65535, -495}, },
            {{0, 8, 547}, {9, 9, 548}, {10, 10, 542}, {11, 12, 547}, {13, 13, 543}, {14, 31, 547}, {32, 32, 549}, {33, 41, 547}, {42, 42, 550}, {43, 46, 547}, {47, 47, 551}, {48, 65535, 547}, },
            {{0, 65535, -497}, },
            {{0, 65535, -495}, },
            {{0, 65535, -360}, },
            {{62, 62, 552}, },
            {{101, 101, 553}, },
            {{116, 116, 554}, },
            {{121, 121, 555}, },
            {{48, 57, 556}, {65, 70, 557}, {97, 102, 558}, },
            {{48, 102, -505}, },
            {{48, 102, -505}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{116, 116, 559}, },
            {},
            {{105, 105, 560}, },
            {},
            {{110, 110, 561}, },
            {{105, 105, 562}, },
            {},
            {{110, 110, 563}, },
            {{101, 101, 564}, },
            {{99, 99, 565}, },
            {{102, 102, 566}, },
            {{119, 119, 567}, },
            {{121, 121, 568}, },
            {{105, 105, 569}, },
            {{112, 112, 570}, },
            {},
            {{101, 101, 571}, },
            {{105, 105, 572}, },
            {{110, 110, 573}, },
            {{110, 110, 574}, },
            {{105, 105, 575}, },
            {{110, 110, 576}, },
            {},
            {{105, 105, 577}, },
            {{101, 101, 578}, },
            {{0, 41, 547}, {42, 42, 550}, {43, 65535, 547}, },
            {{0, 65535, -356}, },
            {{0, 41, -430}, {42, 42, 545}, {43, 65535, -430}, },
            {{0, 65535, -491}, },
            {{0, 41, 534}, {42, 42, 550}, {43, 65535, -483}, },
            {{0, 65535, -424}, },
            {{0, 65535, -495}, },
            {{0, 65535, -495}, },
            {{0, 65535, -497}, },
            {{0, 65535, -497}, },
            {{0, 65535, -495}, },
            {{0, 41, -359}, {42, 42, 545}, {43, 65535, -359}, },
            {{0, 41, -495}, {42, 42, 579}, {43, 46, 540}, {47, 47, 580}, {48, 65535, 540}, },
            {{0, 65535, -536}, },
            {{0, 65535, -497}, },
            {{0, 65535, -497}, },
            {{0, 41, 265}, {42, 42, 550}, {43, 65535, -178}, },
            {{0, 41, 547}, {42, 42, 581}, {43, 46, 547}, {47, 47, 582}, {48, 65535, 547}, },
            {},
            {{120, 120, 583}, },
            {{101, 101, 584}, },
            {{70, 102, -202}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {{36, 122, -122}, },
            {},
            {{110, 110, 585}, },
            {{105, 105, 586}, },
            {{116, 116, 587}, },
            {{116, 116, 588}, },
            {{111, 111, 589}, },
            {{101, 101, 590}, },
            {},
            {{105, 105, 591}, },
            {},
            {{97, 97, 592}, },
            {{101, 101, 593}, },
            {{100, 100, 594}, },
            {{110, 110, 595}, },
            {{118, 118, 596}, },
            {{105, 105, 597}, },
            {{116, 116, 598}, },
            {{116, 116, 599}, },
            {{110, 110, 600}, },
            {},
            {{0, 65535, -538}, },
            {{0, 65535, -548}, },
            {{0, 65535, -540}, },
            {{0, 65535, -495}, },
            {{99, 99, 601}, },
            {{114, 114, 602}, },
            {{116, 116, 603}, },
            {{116, 116, 604}, },
            {{111, 111, 605}, },
            {{115, 115, 606}, },
            {{102, 102, 607}, },
            {{105, 105, 608}, },
            {{116, 116, 609}, },
            {{114, 114, 610}, },
            {},
            {},
            {{118, 118, 611}, },
            {{111, 111, 612}, },
            {{122, 122, 613}, },
            {{99, 99, 614}, },
            {},
            {{118, 118, 615}, },
            {{101, 101, 616}, },
            {{48, 57, 617}, },
            {},
            {{111, 111, 618}, },
            {{114, 114, 619}, },
            {},
            {},
            {{110, 110, 620}, },
            {{99, 99, 621}, },
            {{114, 114, 622}, },
            {{111, 111, 623}, },
            {{107, 107, 624}, },
            {{101, 101, 625}, },
            {{104, 104, 626}, },
            {{111, 111, 627}, },
            {{112, 112, 628}, },
            {{48, 57, 617}, {58, 58, 629}, },
            {{114, 114, 630}, },
            {},
            {{118, 118, 631}, },
            {{104, 104, 632}, },
            {{97, 97, 633}, },
            {{107, 107, 634}, },
            {{101, 101, 635}, },
            {{100, 100, 636}, },
            {},
            {{107, 107, 637}, },
            {{116, 116, 638}, },
            {},
            {},
            {{111, 111, 639}, },
            {},
            {{121, 121, 640}, },
            {{101, 101, 641}, },
            {},
            {},
            {{101, 101, 642}, },
            {{105, 105, 643}, },
            {{107, 107, 644}, },
            {},
            {},
            {},
            {{111, 111, 645}, },
            {{101, 101, 646}, },
            {{110, 110, 647}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 0, 0, 0, 0, -1, -1, -1, 87, 71, 68, 65, 61, 62, 83, 81, 55, 82, 64, 84, 90, 90, 63, 58, 76, 67, 74, -1, 87, 59, -1, 60, 70, 87, 87, 87, 87, 56, 69, 57, -1, 73, -1, 92, -1, -1, -1, -1, -1, -1, 87, -1, 87, 87, -1, 87, 87, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, -1, 90, 90, -1, -1, 66, 78, 77, -1, -1, 72, 75, 79, -1, -1, -1, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, -1, 87, 87, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 85, 85, -1, 85, 85, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, 87, -1, 86, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 36, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, 0, 0, 91, 90, 90, 90, -1, -1, 80, -1, -1, -1, -1, -1, -1, 87, 87, -1, -1, -1, -1, 91, 85, 85, 85, -1, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 29, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, -1, -1, 41, 42, 45, -1, -1, -1, -1, 46, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, 0, -1, 91, -1, 91, -1, -1, -1, -1, -1, -1, -1, -1, 87, 87, -1, -1, -1, -1, 91, 91, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, 85, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 15, 27, -1, 17, -1, 30, 31, -1, -1, -1, -1, -1, -1, -1, 35, -1, -1, -1, -1, 19, -1, -1, -1, -1, 54, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 13, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, -1, -1, 91, -1, -1, -1, -1, -1, -1, -1, -1, 87, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 28, 11, -1, -1, -1, -1, -1, 2, 20, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 16, -1, -1, -1, -1, 51, -1, -1, -1, -1, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 87, -1, -1, 88, 87, 87, 87, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 87, 87, 87, -1, -1, -1, -1, 21, -1, -1, -1, -1, -1, -1, -1, -1, 3, -1, -1, -1, -1, -1, 4, 47, -1, 7, -1, -1, 52, -1, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, -1, -1, -1, -1, -1, -1, -1, 85, 85, 85, -1, 14, -1, 32, -1, -1, 24, -1, -1, -1, -1, -1, -1, -1, -1, 6, -1, -1, -1, -1, -1, -1, 23, -1, -1, -1, 0, 0, 0, -1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 0, 0, -1, -1, 87, -1, -1, 91, 85, 85, 85, 1, -1, -1, -1, -1, -1, -1, 39, -1, 43, -1, -1, -1, -1, -1, -1, -1, -1, -1, 10, 0, 0, -1, 0, -1, -1, -1, -1, -1, -1, -1, 12, -1, -1, 22, 5, -1, -1, -1, -1, 9, -1, -1, -1, 26, -1, -1, 25, 37, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 34, -1, -1, -1, -1, -1, -1, 50, -1, -1, 88, 33, -1, 40, -1, -1, 49, 8, -1, -1, -1, 44, 48, 53, -1, -1, -1, 38, 88, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
