/*
 * File: [CLASS NAME].java
 *
 * File: JPATTest.java
 * Author : Michael Jones
 *
 * Last Modified On: $Date: 1998/12/14 19:45:44 $
 * Last Modified By: $Author: mjones $
 *
 */

import jpat.*;

import java.io.*;

/**
 * [DESCRIPTIVE COMMENT]
 *
 * @see [OTHER CLASSES (optional)]
 */

public class JPATTest
{
	// Static variables
  String mSequence = "MDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTV"	
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
                + "MDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTV"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
                + "MDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTV"	
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY";
//  		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
//  		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
//  		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
//  		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
//  		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
//  		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
//  		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
//  		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
//  		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
//  		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
//  		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
//  		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
//  		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
//  		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
//  		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
//  		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
//  		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
//  		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
//  		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
//  		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
//  		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
//  		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
//  		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
//  		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
//  		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC"
//  		+ "CTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGT"
//  		+ "DRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHP"
//  		+ "QNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCS"
//  		+ "LCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTD"
//  		+ "CRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLR"
//  		+ "ENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKE"
//  		+ "MGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMD"
//  		+ "SVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYW"
//  		+ "SENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLY"
//  		+ "NDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNT"
//  		+ "VCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLR"
//  		+ "HCLSCSKCRKEMGQVEISSCTVDRDTVCGCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECT"
//  		+ "KLCLPQIENMDSVCPQGKYIHPQNNSICCTKCHKGTYLYNDCPGPGQDTDCRECESGSFTASENHLRHCLSCSKCRKEMGQVEISSCTVDRDTVC"
//  		+ "GCRKNQYRHYWSENLFQCFCCSLCLNGTVHLSCQEKQNTVCTCHAGFFLRENECVSCSNCKKSLECTKLCLPQIENMDSVCPQGKYIHPQNNSIC";

	

	// Member variables

	// Constructors and initialization

	public JPATTest(String test)
	{
	    
			if(test.equals("-testDigest")){
					doDigestTest();	
			}else if(test.equals("-testFragment")){
					doFragmentTest();	
			}else System.out.println("Usage java JPATTest -testDigest -testFragment");
			
	}

	// Interface implementations

	// Public methods
  public static void main(String args[])
  {
			if(args.length!=1){
						System.out.println("Usage java JPATTest -testDigest -testFragment");
						System.exit(1);
			}
			new JPATTest(args[0]);
  }

// Protected methods
/*
		Digests a large protein sequence
*/
void doDigestTest()
{
		String protease = "KR";  //Trypsin protease
		Digest digest = new  Digest(mSequence, protease, true);
		Peptide[] peptides= digest.seqDigest();
		int i=0;
		try{
			while(true){
					System.out.println(peptides[i].cTerm + " " + peptides[i].pepSequence + " " + peptides[i].nTerm);
					i++;
			}
		}catch(ArrayIndexOutOfBoundsException e){}
}


void doFragmentTest(){}
// Private methods

}


