package wig.analysis;

import ca.mcgill.sable.util.*;
import wig.node.*;

public interface Analysis extends Switch
{
    Object getIn(Node node);
    void setIn(Node node, Object in);
    Object getOut(Node node);
    void setOut(Node node, Object out);

    void caseStart(Start node);
    void caseAService1Servicep(AService1Servicep node);
    void caseAEmptyGlobalsp(AEmptyGlobalsp node);
    void caseAGlobals1Globalsp(AGlobals1Globalsp node);
    void caseANeglobals1Neglobalsp(ANeglobals1Neglobalsp node);
    void caseANeglobals2Neglobalsp(ANeglobals2Neglobalsp node);
    void caseAGlobal1Globalp(AGlobal1Globalp node);
    void caseAGlobal2Globalp(AGlobal2Globalp node);
    void caseAGlobal3Globalp(AGlobal3Globalp node);
    void caseANenames1Nenamesp(ANenames1Nenamesp node);
    void caseANenames2Nenamesp(ANenames2Nenamesp node);
    void caseAName1Namep(AName1Namep node);
    void caseAEmptyIntinitp(AEmptyIntinitp node);
    void caseAIntinit1Intinitp(AIntinit1Intinitp node);
    void caseAEmptyBoolinitp(AEmptyBoolinitp node);
    void caseABoolinit1Boolinitp(ABoolinit1Boolinitp node);
    void caseABoolinit2Boolinitp(ABoolinit2Boolinitp node);
    void caseATextinit11Textinit1p(ATextinit11Textinit1p node);
    void caseAEmptyTextinitp(AEmptyTextinitp node);
    void caseATextinit1Textinitp(ATextinit1Textinitp node);
    void caseAEmptyStringp(AEmptyStringp node);
    void caseAStringp1Stringp(AStringp1Stringp node);
    void caseAStringp2Stringp(AStringp2Stringp node);
    void caseADocuments1Documentsp(ADocuments1Documentsp node);
    void caseADocuments2Documentsp(ADocuments2Documentsp node);
    void caseADocument1Documentp(ADocument1Documentp node);
    void caseATitle11Title1p(ATitle11Title1p node);
    void caseAEmptyTitlep(AEmptyTitlep node);
    void caseATitle1Titlep(ATitle1Titlep node);
    void caseAHtml1Htmlp(AHtml1Htmlp node);
    void caseAHtml2Htmlp(AHtml2Htmlp node);
    void caseAEntity91pEntity9p(AEntity91pEntity9p node);
    void caseAEntity101pEntity10p(AEntity101pEntity10p node);
    void caseAEntity111pEntity11p(AEntity111pEntity11p node);
    void caseAEntity141pEntity14p(AEntity141pEntity14p node);
    void caseAEntity151pEntity15p(AEntity151pEntity15p node);
    void caseAEntity1611pEntity161p(AEntity1611pEntity161p node);
    void caseAEntity1621pEntity162p(AEntity1621pEntity162p node);
    void caseAEntity1711pEntity171p(AEntity1711pEntity171p node);
    void caseAEntity1811pEntity181p(AEntity1811pEntity181p node);
    void caseAEntity1821pEntity182p(AEntity1821pEntity182p node);
    void caseAEntity1831pEntity183p(AEntity1831pEntity183p node);
    void caseAEntity1841pEntity184p(AEntity1841pEntity184p node);
    void caseAEntity1sEntityp(AEntity1sEntityp node);
    void caseAEntity1nEntityp(AEntity1nEntityp node);
    void caseAEntity1tEntityp(AEntity1tEntityp node);
    void caseAEntity1fEntityp(AEntity1fEntityp node);
    void caseAEntity2Entityp(AEntity2Entityp node);
    void caseAEntity3Entityp(AEntity3Entityp node);
    void caseAEntity4Entityp(AEntity4Entityp node);
    void caseAEntity5Entityp(AEntity5Entityp node);
    void caseAEntity6Entityp(AEntity6Entityp node);
    void caseAEntity7Entityp(AEntity7Entityp node);
    void caseAEntity8Entityp(AEntity8Entityp node);
    void caseAEntity9Entityp(AEntity9Entityp node);
    void caseAEntity10Entityp(AEntity10Entityp node);
    void caseAEntity11Entityp(AEntity11Entityp node);
    void caseAEntity12Entityp(AEntity12Entityp node);
    void caseAEntity13Entityp(AEntity13Entityp node);
    void caseAEntity14Entityp(AEntity14Entityp node);
    void caseAEntity15Entityp(AEntity15Entityp node);
    void caseAEntity16Entityp(AEntity16Entityp node);
    void caseAEntity17Entityp(AEntity17Entityp node);
    void caseAEntity18Entityp(AEntity18Entityp node);
    void caseAOptions1Optionsp(AOptions1Optionsp node);
    void caseAOptions2Optionsp(AOptions2Optionsp node);
    void caseAOption11Option1p(AOption11Option1p node);
    void caseAOption1Optionp(AOption1Optionp node);
    void caseALiterals1Literalsp(ALiterals1Literalsp node);
    void caseALiterals2Literalsp(ALiterals2Literalsp node);
    void caseALiteral1Literalp(ALiteral1Literalp node);
    void caseALiteral2Literalp(ALiteral2Literalp node);
    void caseALiteral3Literalp(ALiteral3Literalp node);
    void caseALiteral4Literalp(ALiteral4Literalp node);
    void caseAItems1Itemsp(AItems1Itemsp node);
    void caseAItems2Itemsp(AItems2Itemsp node);
    void caseAItem1Itemp(AItem1Itemp node);
    void caseARows1Rowsp(ARows1Rowsp node);
    void caseARows2Rowsp(ARows2Rowsp node);
    void caseARow1Rowp(ARow1Rowp node);
    void caseAEntries1Entriesp(AEntries1Entriesp node);
    void caseAEntries2Entriesp(AEntries2Entriesp node);
    void caseAEntry1Entryp(AEntry1Entryp node);
    void caseAEmptyArgumentsp(AEmptyArgumentsp node);
    void caseAArguments1Argumentsp(AArguments1Argumentsp node);
    void caseANearguments1Neargumentsp(ANearguments1Neargumentsp node);
    void caseANearguments2Neargumentsp(ANearguments2Neargumentsp node);
    void caseAArgument11Argument1p(AArgument11Argument1p node);
    void caseAArgument31Argument3p(AArgument31Argument3p node);
    void caseAArgdum1Argdump(AArgdum1Argdump node);
    void caseAArgument1Argumentp(AArgument1Argumentp node);
    void caseAArgument2Argumentp(AArgument2Argumentp node);
    void caseAArgument3Argumentp(AArgument3Argumentp node);
    void caseASessions1Sessionsp(ASessions1Sessionsp node);
    void caseASessions2Sessionsp(ASessions2Sessionsp node);
    void caseASession1Sessionp(ASession1Sessionp node);
    void caseATermination11Termination1p(ATermination11Termination1p node);
    void caseAEmptyTerminationp(AEmptyTerminationp node);
    void caseATermination1Terminationp(ATermination1Terminationp node);
    void caseAEmptyLocalsp(AEmptyLocalsp node);
    void caseALocals1Localsp(ALocals1Localsp node);
    void caseANelocals1Nelocalsp(ANelocals1Nelocalsp node);
    void caseANelocals2Nelocalsp(ANelocals2Nelocalsp node);
    void caseALocal1Localp(ALocal1Localp node);
    void caseALocal2Localp(ALocal2Localp node);
    void caseALocal3Localp(ALocal3Localp node);
    void caseAEmptyIntinitsp(AEmptyIntinitsp node);
    void caseAIntinits1Intinitsp(AIntinits1Intinitsp node);
    void caseAEmptyBoolinitsp(AEmptyBoolinitsp node);
    void caseABoolinits1Boolinitsp(ABoolinits1Boolinitsp node);
    void caseABoolinits2Boolinitsp(ABoolinits2Boolinitsp node);
    void caseATextinits11Textinit1sp(ATextinits11Textinit1sp node);
    void caseAEmptyTextinitsp(AEmptyTextinitsp node);
    void caseATextinits1Textinitsp(ATextinits1Textinitsp node);
    void caseAStatement711Statement71p(AStatement711Statement71p node);
    void caseAEmptyStatement72p(AEmptyStatement72p node);
    void caseAStatement721Statement72p(AStatement721Statement72p node);
    void caseAEmptyStatementp(AEmptyStatementp node);
    void caseAStatement1Statementp(AStatement1Statementp node);
    void caseAStatement2Statementp(AStatement2Statementp node);
    void caseAStatement3Statementp(AStatement3Statementp node);
    void caseAStatement5Statementp(AStatement5Statementp node);
    void caseAStatement7Statementp(AStatement7Statementp node);
    void caseAStatement8Statementp(AStatement8Statementp node);
    void caseAStatementseq1Statementseqp(AStatementseq1Statementseqp node);
    void caseAStatementseq2Statementseqp(AStatementseq2Statementseqp node);
    void caseAEmptyParametersp(AEmptyParametersp node);
    void caseAParameters1Parametersp(AParameters1Parametersp node);
    void caseAParameters2Parametersp(AParameters2Parametersp node);
    void caseANeparlist1Neparlistp(ANeparlist1Neparlistp node);
    void caseANeparlist2Neparlistp(ANeparlist2Neparlistp node);
    void caseAParameter21Parameter2p(AParameter21Parameter2p node);
    void caseAParameter1Parameterp(AParameter1Parameterp node);
    void caseAParameter2Parameterp(AParameter2Parameterp node);
    void caseAExppIntExppInt(AExppIntExppInt node);
    void caseAExp1Expp(AExp1Expp node);
    void caseAExp2Expp(AExp2Expp node);
    void caseAOrexp1Orexpp(AOrexp1Orexpp node);
    void caseAOrexp2Orexpp(AOrexp2Orexpp node);
    void caseAAndexp1Andexpp(AAndexp1Andexpp node);
    void caseAAndexp2Andexpp(AAndexp2Andexpp node);
    void caseAEqexp1Eqexpp(AEqexp1Eqexpp node);
    void caseAEqexp2Eqexpp(AEqexp2Eqexpp node);
    void caseARelexp1Relexpp(ARelexp1Relexpp node);
    void caseARelexp2Relexpp(ARelexp2Relexpp node);
    void caseAAddexp1Addexpp(AAddexp1Addexpp node);
    void caseAAddexp2Addexpp(AAddexp2Addexpp node);
    void caseAAddexp3Addexpp(AAddexp3Addexpp node);
    void caseAAddexp4Addexpp(AAddexp4Addexpp node);
    void caseAMultexp1Multexpp(AMultexp1Multexpp node);
    void caseAMultexp2Multexpp(AMultexp2Multexpp node);
    void caseAMultexp3Multexpp(AMultexp3Multexpp node);
    void caseAMultexp4Multexpp(AMultexp4Multexpp node);
    void caseAUnaryexp1Unaryexpp(AUnaryexp1Unaryexpp node);
    void caseAUnaryexp2Unaryexpp(AUnaryexp2Unaryexpp node);
    void caseAAbsExp1AbsExpp(AAbsExp1AbsExpp node);
    void caseAUnaryexpnm1Unaryexpnmp(AUnaryexpnm1Unaryexpnmp node);
    void caseAUnaryexpnm2Unaryexpnmp(AUnaryexpnm2Unaryexpnmp node);
    void caseAUnaryexpnm3Unaryexpnmp(AUnaryexpnm3Unaryexpnmp node);
    void caseAUnaryexpnm4Unaryexpnmp(AUnaryexpnm4Unaryexpnmp node);
    void caseAUnaryexpnm5Unaryexpnmp(AUnaryexpnm5Unaryexpnmp node);
    void caseAPostfixexp1Postfixexpp(APostfixexp1Postfixexpp node);
    void caseAPostfixexp2Postfixexpp(APostfixexp2Postfixexpp node);
    void caseAPrimexp1Primexpp(APrimexp1Primexpp node);
    void caseAPrimexp2Primexpp(APrimexp2Primexpp node);

    void caseTService(TService node);
    void caseTDocument(TDocument node);
    void caseTSession(TSession node);
    void caseTGlobal(TGlobal node);
    void caseTLocal(TLocal node);
    void caseTAssignSes(TAssignSes node);
    void caseTStop(TStop node);
    void caseTTake(TTake node);
    void caseTShow(TShow node);
    void caseTIn(TIn node);
    void caseTOut(TOut node);
    void caseTRandom(TRandom node);
    void caseTSystem(TSystem node);
    void caseTBool(TBool node);
    void caseTText(TText node);
    void caseTInt(TInt node);
    void caseTIf(TIf node);
    void caseTElse(TElse node);
    void caseTWhile(TWhile node);
    void caseTEqualSes(TEqualSes node);
    void caseTGt(TGt node);
    void caseTAnd(TAnd node);
    void caseTNot(TNot node);
    void caseTOr(TOr node);
    void caseTAutoInc(TAutoInc node);
    void caseTInterval(TInterval node);
    void caseTPlus(TPlus node);
    void caseTMinus(TMinus node);
    void caseTMultiply(TMultiply node);
    void caseTDivide(TDivide node);
    void caseTModulo(TModulo node);
    void caseTAbs(TAbs node);
    void caseTSemicolon(TSemicolon node);
    void caseTLeftBrack(TLeftBrack node);
    void caseTRightBrack(TRightBrack node);
    void caseTLeftParen(TLeftParen node);
    void caseTRightParen(TRightParen node);
    void caseTEnds(TEnds node);
    void caseTWith(TWith node);
    void caseTLeftBrack1(TLeftBrack1 node);
    void caseTRightBrack1(TRightBrack1 node);
    void caseTString(TString node);
    void caseTComma(TComma node);
    void caseTIdentifier(TIdentifier node);
    void caseTNumber(TNumber node);
    void caseTTrue(TTrue node);
    void caseTFalse(TFalse node);
    void caseTSpecify(TSpecify node);
    void caseTAssignNormaldoc(TAssignNormaldoc node);
    void caseTBold(TBold node);
    void caseTBoldEnd(TBoldEnd node);
    void caseTItalic(TItalic node);
    void caseTItalicEnd(TItalicEnd node);
    void caseTHeader1(THeader1 node);
    void caseTHeader1End(THeader1End node);
    void caseTHeader2(THeader2 node);
    void caseTHeader2End(THeader2End node);
    void caseTPara(TPara node);
    void caseTBr(TBr node);
    void caseTHr(THr node);
    void caseTImg(TImg node);
    void caseTSrc(TSrc node);
    void caseTInclude(TInclude node);
    void caseTFile(TFile node);
    void caseTA(TA node);
    void caseTAEnd(TAEnd node);
    void caseTOpenBr(TOpenBr node);
    void caseTHref(THref node);
    void caseTList(TList node);
    void caseTListEnd(TListEnd node);
    void caseTLi(TLi node);
    void caseTTr(TTr node);
    void caseTTrEnd(TTrEnd node);
    void caseTTd(TTd node);
    void caseTTdEnd(TTdEnd node);
    void caseTTable(TTable node);
    void caseTTableEnd(TTableEnd node);
    void caseTVar(TVar node);
    void caseTSelect(TSelect node);
    void caseTInput(TInput node);
    void caseTParam(TParam node);
    void caseTResult(TResult node);
    void caseTName(TName node);
    void caseTAssignSp2(TAssignSp2 node);
    void caseTStringSp4(TStringSp4 node);
    void caseTType(TType node);
    void caseTSize(TSize node);
    void caseTValue(TValue node);
    void caseTTextConst(TTextConst node);
    void caseTRadio(TRadio node);
    void caseTApplet(TApplet node);
    void caseTAppletEnd(TAppletEnd node);
    void caseTSelectEnd(TSelectEnd node);
    void caseTCodebase(TCodebase node);
    void caseTCode(TCode node);
    void caseTWidth(TWidth node);
    void caseTHeight(THeight node);
    void caseTCloseBr(TCloseBr node);
    void caseTQuote(TQuote node);
    void caseTClose(TClose node);
    void caseTBlank(TBlank node);
    void caseTComment(TComment node);
    void caseTString1(TString1 node);
    void caseEOF(EOF node);
}
