import java.util.*;

/* Tests static method binding of synchronized methods. */
public class Main extends Thread
{
    public void run()
    {
        synchronized(Victim.class)
            {
                synchronized(this)
                    {
                        this.notifyAll();
                    }
                try {
                    Thread.sleep(20000L);
                }
                catch (InterruptedException e) {}
            }
    }

    public static void main(String[] argv)
    {
        new Thread() {
            // Hacked deadlock detector.
            public void run()
            {
                try
                    {
                        Thread.sleep(10000L);
                    }
                catch(InterruptedException e)
                    {
                    }

                System.out.println("Deadlock probable!  Quitting.");
                System.exit(1);
            }
        }.start();

        // Synchronize on the class object for Victim
        // This way, if callee uses the Victim class lock instead,
        // it deadlocks.
        Main m = new Main();
        synchronized(m)
            {
                m.start();
                try
                {
                    m.wait();
                }
                catch(InterruptedException e) {}
            }

        Victim v = new Victim();

        v.callee(true);
        System.exit(0);
    }
}

